
import java.awt.*;
import RDFPanel;
import EnergyPanel;
import TempPanel;
import Simulation;

public class CardPanel extends Panel {

    private Panel cards;
    private Panel tabs;
    private CardLayout layout;
    private CheckboxGroup cg;
    private Simulation s;
    private EnergyPanel ePanel;
    private TempPanel tPanel;
    private RDFPanel rdfPanel;
    private PotentialPanel potPanel;
    private Color tabsColor = new Color(150,150,200);

    public CardPanel(Simulation s) {
	this.s = s;
	setLayout(new BorderLayout());
	tabs = new Panel();
	tabs.setLayout(new FlowLayout());
	cg = new CheckboxGroup();
	tabs.add(new Checkbox("RDF",cg,false));
	tabs.add(new Checkbox("Energy",cg,true));
	tabs.add(new Checkbox("Temperature",cg,false));
	tabs.add(new Checkbox("Potential",cg,false));
	tabs.setBackground(tabsColor);
	add("North",tabs);

	cards = new Panel();
	layout = new CardLayout();
	cards.setLayout(layout);

	tPanel = new TempPanel(s);
	cards.add("Temperature",tPanel);
	ePanel = new EnergyPanel(s);
	cards.add("Energy", ePanel);
	rdfPanel = new RDFPanel(s);
	cards.add("RDF", rdfPanel);
	potPanel = new PotentialPanel(s);
	cards.add("Potential",potPanel);
	add("Center",cards);

	layout.show(cards, "Energy");
    }

    public boolean action(Event e, Object arg) {
	if(e.target instanceof Checkbox &&
	   (((Checkbox)e.target).getParent().equals(tabs))) {
	    layout.show(cards, ((Checkbox)e.target).getLabel());
	}
	else return super.action(e,arg);
	return true;
    }

    public void update() {
	Checkbox cb;

	cb = cg.getCurrent();
	if((cb.getLabel()).equals("Energy"))
	    ePanel.update();
	if((cb.getLabel()).equals("Temperature"))
	    tPanel.update();
	if((cb.getLabel()).equals("RDF")) {
	    rdfPanel.update();
	}
    }
}
