
import java.awt.*;

public class EnergyPanel extends Panel {

    private LinePlot plot;
    private Simulation s;
    private static final double NA = 6.0221367e23;
    private static final double e = 1.60217733e-19;

    public EnergyPanel(Simulation s) {
	plot = new LinePlot();
	this.s = s;
	
	setLayout(new BorderLayout());
	setFont(new Font("TimesRoman",Font.PLAIN,14));
	add("North",new Label("Energy Plot",Label.CENTER));
	add("West",new Label("E",Label.RIGHT));
	add("South",new Label("timestep",Label.CENTER));
	add("Center",plot);
    }

    public void update() {
	plot.plotData(conv2ev(s.te));
    }

    private double conv2ev(double n) {
	return (n * (10.0 / ( e * NA )));
    }

}
