
public class LinkedList {
  private Link head;
  private Link tail;
  private Link pre;
  private int len;

  public void reset() {
    pre = null;
  }

  public boolean hasMoreElements() {
    return cursor() != null;
  }

  public Object nextElement() {
    if( pre == null) pre = head; else pre = pre.next;
    if( pre == null) 
      throw new java.util.NoSuchElementException();
    return pre.data;
  }

  public Object currentElement() {
    Link cur = cursor();
    if(cur == null)
      throw new java.util.NoSuchElementException();
    return cur.data;
  }
  
  public void insert(Object n) {
    Link p = new Link(n,cursor());
    
    if( pre != null) {
      pre.next = p;
      if(pre == tail) tail = p;
    } else {
      if(head == null) tail = p;
      head = p;
    }
    pre = p;
    len++;
  }

  public void append(Object n) {
    Link p = new Link(n, null);
    if(head == null) head = tail = p;
    else {
      tail.next = p;
      tail = p;
    }
    len++;
  }

  public Object remove() {
    Link cur = cursor();
    if(cur == null)
      throw new java.util.NoSuchElementException();
    if(tail == cur) tail = pre;
    if(pre != null) pre.next = cur.next;
    else head = cur.next;
    len--;
    return cur.data;
  }

  int size() {
    return len;
  }

  public java.util.Enumeration elements() {
    return new ListEnumeration(head);
  }

  private Link cursor() {
    if (pre == null) return head; else return pre.next;
  }
}

class Link {
  Object data;
  Link next;
  Link(Object d, Link n) {
    data = d;
    next = n;
  }
}

class ListEnumeration implements java.util.Enumeration {
  public ListEnumeration(Link l) {
    cursor = l;
    head = l;
  }

  public boolean hasMoreElements() {
    return cursor != null;
  }

  public Object nextElement() {
    if(cursor == null) 
      throw new java.util.NoSuchElementException();
    Object r = cursor.data;
    cursor = cursor.next;
    return r;
  }
  private Link head;
  private Link cursor;

}
