
import java.awt.*;
import MDInterface;
import MDDemo;
import Simulation;
import java.util.*;
import Atom;

public class SimulationRegion extends Canvas {
    Point point = null;
    MDInterface controller;
    Simulation s;
    final static int WIDTH = 250;
    final static int HEIGHT = 250;
    final static int radius = 4;
    Image imageBuff = null;
    Graphics graphics;
    private Color bgColor = Color.white;
    private Color atomColor = Color.red;

  public SimulationRegion(MDInterface controller,Simulation s) {
    super();
    this.controller = controller;
    this.s = s;
    this.resize(WIDTH,HEIGHT);
  }

  public void paint(Graphics g) {
      update(g);
  }

    public void update(Graphics g) {
	Atom a;
	double xfactor = WIDTH / s.regionEdge ;
	double yfactor = HEIGHT / s.regionEdge ;
	int x,y;

	if (imageBuff == null) {
	    imageBuff = createImage(WIDTH,HEIGHT);
	    if(imageBuff == null) {
		System.out.println("image = null!!");
		System.exit(0);
	    }
	    graphics = imageBuff.getGraphics();
	}

	// Draw into buffer first and then output to the canvas.

	// Draw background.

	graphics.setColor(bgColor);
	graphics.fillRect(0,0,WIDTH,HEIGHT);

	// Draw atoms
	graphics.setColor(atomColor);
	Enumeration e = s.atoms.elements();
	while(e.hasMoreElements()) {
	    a = (Atom)e.nextElement();
	    x = (int)((a.x + s.hregionEdge) * xfactor);
	    y = (int)((a.y + s.hregionEdge) * yfactor);
	    graphics.fillOval(x,y,2 * radius, 2 * radius);
	}

	// Now output the buffer
	g.drawImage(imageBuff,0,0,this);
    }
}
